// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: ARF
// Author: Richard Saxton
//
// Description: Provides an interface to ARF data
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: ARF.cc,v 1.1 2013/06/06 15:57:39 rsaxton Exp $

// General classes
#include<cassert>

#include <string>
#include <iostream>
#include <vector>
#include <map>

// SAS-specific classes

#include "Dal.h"
#include "errstr.h"
#include "EnergySpectrum.h"
#include "ARF.h"
#include "CalOalUtility.h"

// Utility functions
#include "Tracer.h"

// -----------------------------------------------------------------------------------

// class ARF

// Supports data consisting of an energy, energy width and effective area

// -----------------------------------------------------------------------------------

  /* Constructor - from a fluxed spectrum */
  ARF::ARF(const string & arfName)
    {
      PROC;

      // Read file
      DataSet * set   = dataSetServer->open(arfName, DataSet::Read);
     
      // Open the spectrum table
      Table * table = set->table("SPECRESP");

      // Store the table size
      _N = table->rows();

      // Read in the energy_lo, energy_hi and specresp columns
      vector<float> energy_lo, energy_hi;
      CalOalUtility::fillVector(table, "ENERG_LO", energy_lo);
      CalOalUtility::fillVector(table, "ENERG_HI", energy_hi);
      CalOalUtility::fillVector(table, "SPECRESP", _value);

      // Save the central energy, energy_width and value arrays
      for (int i=0; i<_N; i++) {
          _energy.push_back(float((energy_lo[i] + energy_hi[i]) / 2.0));
          _energyWidth.push_back(float(energy_hi[i] - energy_lo[i]));
      }
 
      // Close up
     // delete table; table=0;
     // dataSetServer->close(set);
    }

/* Destructor */
ARF:: ~ARF()
{
  PROC;
  ENDPROC;
};


