// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: FluxedSpectrum
// Author: Richard Saxton
//
// Description: 
// Provides an clean interface to a fluxed spectrum or to an ARF
// 
// Comments: 
//  
// Modifications: See ChangeLog
// 
// $Id: FluxedSpectrum.h,v 1.1 2013/06/06 15:57:39 rsaxton Exp $

#ifndef FluxedSpectrum_H
#define FluxedSpectrum_H

// General classes
#include<cassert>

#include <string>
#include <iostream>
#include <vector>
#include <map>

// SAS-specific classes

#include "Dal.h"
#include "errstr.h"
#include "EnergySpectrum.h"

// Utility functions
#include "Tracer.h"

// -----------------------------------------------------------------------------------

// class FluxedSpectrum

// Supports data consisting of an energy, energy width and data value

// -----------------------------------------------------------------------------------

class FluxedSpectrum : public EnergySpectrum 
{
public:

  /* Constructor - from a fluxed spectrum */
  FluxedSpectrum(const string & fluxedspectrumName);

  /* Destructor */
  ~FluxedSpectrum();

  /* Member fields */
  /* Methods */


// Method: convFluxCrate - calculates the count rate in each energy bin
  vector<float> convFluxCrate(vector<float> flux) const;

// Method: flux - return the flux in each bin ergs/s/cm^2
  vector<float> flux() const;

// Method: value - inherited from EnergySpectrum returns the 
//                 count rate / cm^2 in each bin

private:

  // Suppress default constructor
  FluxedSpectrum();

  // Variables
  vector<float> _flux;

};


#endif




