//
// Module: LightCurveMaker
// Author: Richard Saxton 
//
// Description: Creates a spectrum using evselect
//
// Modifications: See ChangeLog
//

#ifndef LightCurveMaker_H
#define LightCurveMaker_H

/* General classes */
#include <iostream>

/* SAS-specific classes */
#include <Tracer.h>
#include <metatask.h>
#include <errstr.h>
#include <param.h>
#include <Dal.h>
#include <Xmm.h>

/* Local Classes */
#include <DatafileAttributes.h>

/****************************************************
 *
 * class LightCurveMaker
 *
 ***************************************************/

class LightCurveMaker
{
public:

  /* Constructor */
  LightCurveMaker(string lcurvefile, DatafileAttributes * timeAttributes, 
                  string expression, double timebin);

  /* Destructor */
  ~LightCurveMaker();

private:


  /* Member fields */

  Xmm::Instrument       _instrumentID;
  string               _instr;
  string               _lcurvefile;
  string               _flagexp;
  string               _pattexp;
  double               _timebin;

};

#endif

