//
// Module: SpectrumMaker
// Author: Richard Saxton 
//
// Description: Creates a spectrum using evselect
//
// Modifications: See ChangeLog
//

#ifndef SpectrumMaker_H
#define SpectrumMaker_H

/* General classes */
#include <iostream>

/* SAS-specific classes */
#include <Tracer.h>
#include <metatask.h>
#include <errstr.h>
#include <param.h>
#include <Dal.h>
#include <Xmm.h>
#include "DatafileAttributes.h"

/* Local Classes */

/****************************************************
 *
 * class SpectrumMaker
 *
 ***************************************************/

class SpectrumMaker
{
public:

  /* Constructor */
  SpectrumMaker(string spectrumfile, DatafileAttributes * specAttributes, 
                                                         string expression,bool multiEPICspec);

  /* Destructor */
  ~SpectrumMaker();

  /* Method to add keywords to spectrum */
  void addkeywords(string bgdfile,
                                string rspfile, string arffile);

private:


  /* Member fields */

  Xmm::Instrument       _instrumentID;
  string               _instr;
  int                  _specbin;
  double	       _specmin;
  double               _specmax;
  string               _spectrumfile;
  string               _flagexp;
  string               _pattexp;

};

#endif

