// -*-C++-*-
//
// File:      WcsCC.h
// Author:    Jorgo Bakker (jbakker@astro.estec.esa.nl)
// Generated: Fri Aug  9 16:49:17 MEST 2002

#ifndef WcsCC_h
#define WcsCC_h
#include <cstring>

//#include "DopeVector.h"

class WcsCC;
//F90MODPROCDEF(void,wcscc_mod,new_)(WcsCC*,const DataSet*, const Array*);
F90MODPROCDEF(void,wcscc_mod,new_)(WcsCC*,const char* filename);
F90MODPROCDEF(void,wcscc_mod,delete_)(WcsCC*);

// Define the data structure - equivalent to that of FORTRAN WcsT
/*
struct WcsAxisTcc
{
   character(len=8) ::&
      ctype,&           // CTYPE
      worldUnit         // CUNIT
    double matrixOnAxis,   // CD1_
      matrixOffAxis,   // CD2_
      refPixels,       // CRPIX
      refWorld;          // CRVAL
};

struct wcscc
{
   WcsAxisTcc x,y;
   boolean crotFound;
};

*/
//class WcsCC : public DopeVector<WcsCC>
class WcsCC 
{
public:
  // f90:: allocate(WcsCC(length))
//  WcsCC(DataSet *set, Array *array)
//  {
//    F90MODPROC(wcscc_mod, new_)(this, set, array);
//  }

  WcsCC(const string &filename)
  {
    unsigned f90sLen=filename.length();
    char f90_filename[f90sLen];
    stringf90(filename, f90_filename, f90sLen);
    cout<<"NAME is: "<<filename<<endl;
    cout<<"FNAME is: "<<f90_filename<<" "<<f90sLen<<endl;
    F90MODPROC(wcscc_mod, new_)(this, f90_filename);
    //F90MODPROC(wcscc_mod, new_)(this, 
      //              stringf90(filename, f90_filename, f90sLen));
    //F90MODPROC(wcscc_mod, new_)(this, 'imagepnxy.ds');
  }

  // f90:: deallocate(WcsCC)
  ~WcsCC()
  {
    F90MODPROC(wcscc_mod,delete_)(this);
  }
private:
   // disabled member functions
  WcsCC();
  WcsCC(const WcsCC&);
  WcsCC& operator=(const WcsCC&);
};


#endif
